<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>CookieSpecBase xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/cookie/CookieSpecBase.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/cookie/CookieSpecBase.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em> 
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/package-summary.html">org.apache.commons.httpclient.cookie</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.util.Collection;
<a name="34" href="#34">34</a>  <strong>import</strong> java.util.Date;
<a name="35" href="#35">35</a>  <strong>import</strong> java.util.LinkedList;
<a name="36" href="#36">36</a>  <strong>import</strong> java.util.List;
<a name="37" href="#37">37</a>  
<a name="38" href="#38">38</a>  <strong>import</strong> org.apache.commons.httpclient.Cookie;
<a name="39" href="#39">39</a>  <strong>import</strong> org.apache.commons.httpclient.Header;
<a name="40" href="#40">40</a>  <strong>import</strong> org.apache.commons.httpclient.HeaderElement;
<a name="41" href="#41">41</a>  <strong>import</strong> org.apache.commons.httpclient.NameValuePair;
<a name="42" href="#42">42</a>  <strong>import</strong> org.apache.commons.httpclient.util.DateParseException;
<a name="43" href="#43">43</a>  <strong>import</strong> org.apache.commons.httpclient.util.DateUtil;
<a name="44" href="#44">44</a>  <strong>import</strong> org.apache.commons.logging.Log;
<a name="45" href="#45">45</a>  <strong>import</strong> org.apache.commons.logging.LogFactory;
<a name="46" href="#46">46</a>  
<a name="47" href="#47">47</a>  <em>/**<em>*</em></em>
<a name="48" href="#48">48</a>  <em> * </em>
<a name="49" href="#49">49</a>  <em> * Cookie management functions shared by all specification.</em>
<a name="50" href="#50">50</a>  <em> *</em>
<a name="51" href="#51">51</a>  <em> * @author  B.C. Holmes</em>
<a name="52" href="#52">52</a>  <em> * @author &lt;a href="<a href="mailto:jericho@thinkfree.com" target="alexandria_uri">mailto:jericho@thinkfree.com</a>">Park, Sung-Gu&lt;/a></em>
<a name="53" href="#53">53</a>  <em> * @author &lt;a href="<a href="mailto:dsale@us.britannica.com" target="alexandria_uri">mailto:dsale@us.britannica.com</a>">Doug Sale&lt;/a></em>
<a name="54" href="#54">54</a>  <em> * @author Rod Waldhoff</em>
<a name="55" href="#55">55</a>  <em> * @author dIon Gillard</em>
<a name="56" href="#56">56</a>  <em> * @author Sean C. Sullivan</em>
<a name="57" href="#57">57</a>  <em> * @author &lt;a href="<a href="mailto:JEvans@Cyveillance.com" target="alexandria_uri">mailto:JEvans@Cyveillance.com</a>">John Evans&lt;/a></em>
<a name="58" href="#58">58</a>  <em> * @author Marc A. Saegesser</em>
<a name="59" href="#59">59</a>  <em> * @author &lt;a href="<a href="mailto:oleg@ural.ru" target="alexandria_uri">mailto:oleg@ural.ru</a>">Oleg Kalnichevski&lt;/a></em>
<a name="60" href="#60">60</a>  <em> * @author &lt;a href="<a href="mailto:mbowler@GargoyleSoftware.com" target="alexandria_uri">mailto:mbowler@GargoyleSoftware.com</a>">Mike Bowler&lt;/a></em>
<a name="61" href="#61">61</a>  <em> * </em>
<a name="62" href="#62">62</a>  <em> * @since 2.0 </em>
<a name="63" href="#63">63</a>  <em> */</em>
<a name="64" href="#64">64</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/CookieSpecBase.html">CookieSpecBase</a> implements <a href="../../../../../org/apache/commons/httpclient/cookie/CookieSpec.html">CookieSpec</a> {
<a name="65" href="#65">65</a>      
<a name="66" href="#66">66</a>      <em>/**<em>* Log object */</em></em>
<a name="67" href="#67">67</a>      <strong>protected</strong> <strong>static</strong> <strong>final</strong> Log LOG = LogFactory.getLog(CookieSpec.<strong>class</strong>);
<a name="68" href="#68">68</a>  
<a name="69" href="#69">69</a>      <em>/**<em>* Valid date patterns */</em></em>
<a name="70" href="#70">70</a>      <strong>private</strong> Collection datepatterns = <strong>null</strong>;
<a name="71" href="#71">71</a>      
<a name="72" href="#72">72</a>      <em>/**<em>* Default constructor */</em></em>
<a name="73" href="#73">73</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/CookieSpecBase.html">CookieSpecBase</a>() {
<a name="74" href="#74">74</a>          <strong>super</strong>();
<a name="75" href="#75">75</a>      }
<a name="76" href="#76">76</a>  
<a name="77" href="#77">77</a>  
<a name="78" href="#78">78</a>      <em>/**<em>*</em></em>
<a name="79" href="#79">79</a>  <em>      * Parses the Set-Cookie value into an array of &lt;tt>Cookie&lt;/tt>s.</em>
<a name="80" href="#80">80</a>  <em>      *</em>
<a name="81" href="#81">81</a>  <em>      * &lt;P>The syntax for the Set-Cookie response header is:</em>
<a name="82" href="#82">82</a>  <em>      *</em>
<a name="83" href="#83">83</a>  <em>      * &lt;PRE></em>
<a name="84" href="#84">84</a>  <em>      * set-cookie      =    "Set-Cookie:" cookies</em>
<a name="85" href="#85">85</a>  <em>      * cookies         =    1#cookie</em>
<a name="86" href="#86">86</a>  <em>      * cookie          =    NAME "=" VALUE * (";" cookie-av)</em>
<a name="87" href="#87">87</a>  <em>      * NAME            =    attr</em>
<a name="88" href="#88">88</a>  <em>      * VALUE           =    value</em>
<a name="89" href="#89">89</a>  <em>      * cookie-av       =    "Comment" "=" value</em>
<a name="90" href="#90">90</a>  <em>      *                 |    "Domain" "=" value</em>
<a name="91" href="#91">91</a>  <em>      *                 |    "Max-Age" "=" value</em>
<a name="92" href="#92">92</a>  <em>      *                 |    "Path" "=" value</em>
<a name="93" href="#93">93</a>  <em>      *                 |    "Secure"</em>
<a name="94" href="#94">94</a>  <em>      *                 |    "Version" "=" 1*DIGIT</em>
<a name="95" href="#95">95</a>  <em>      * &lt;/PRE></em>
<a name="96" href="#96">96</a>  <em>      *</em>
<a name="97" href="#97">97</a>  <em>      * @param host the host from which the &lt;tt>Set-Cookie&lt;/tt> value was</em>
<a name="98" href="#98">98</a>  <em>      * received</em>
<a name="99" href="#99">99</a>  <em>      * @param port the port from which the &lt;tt>Set-Cookie&lt;/tt> value was</em>
<a name="100" href="#100">100</a> <em>      * received</em>
<a name="101" href="#101">101</a> <em>      * @param path the path from which the &lt;tt>Set-Cookie&lt;/tt> value was</em>
<a name="102" href="#102">102</a> <em>      * received</em>
<a name="103" href="#103">103</a> <em>      * @param secure &lt;tt>true&lt;/tt> when the &lt;tt>Set-Cookie&lt;/tt> value was</em>
<a name="104" href="#104">104</a> <em>      * received over secure conection</em>
<a name="105" href="#105">105</a> <em>      * @param header the &lt;tt>Set-Cookie&lt;/tt> received from the server</em>
<a name="106" href="#106">106</a> <em>      * @return an array of &lt;tt>Cookie&lt;/tt>s parsed from the Set-Cookie value</em>
<a name="107" href="#107">107</a> <em>      * @throws MalformedCookieException if an exception occurs during parsing</em>
<a name="108" href="#108">108</a> <em>      */</em>
<a name="109" href="#109">109</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] parse(String host, <strong>int</strong> port, String path, 
<a name="110" href="#110">110</a>         <strong>boolean</strong> secure, <strong>final</strong> String header) 
<a name="111" href="#111">111</a>         throws <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> {
<a name="112" href="#112">112</a>             
<a name="113" href="#113">113</a>         LOG.trace(<span class="string">"enter CookieSpecBase.parse("</span> 
<a name="114" href="#114">114</a>             + <span class="string">"String, port, path, boolean, Header)"</span>);
<a name="115" href="#115">115</a> 
<a name="116" href="#116">116</a>         <strong>if</strong> (host == <strong>null</strong>) {
<a name="117" href="#117">117</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="118" href="#118">118</a>                 <span class="string">"Host of origin may not be null"</span>);
<a name="119" href="#119">119</a>         }
<a name="120" href="#120">120</a>         <strong>if</strong> (host.trim().equals(<span class="string">""</span>)) {
<a name="121" href="#121">121</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="122" href="#122">122</a>                 <span class="string">"Host of origin may not be blank"</span>);
<a name="123" href="#123">123</a>         }
<a name="124" href="#124">124</a>         <strong>if</strong> (port &lt; 0) {
<a name="125" href="#125">125</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Invalid port: "</span> + port);
<a name="126" href="#126">126</a>         }
<a name="127" href="#127">127</a>         <strong>if</strong> (path == <strong>null</strong>) {
<a name="128" href="#128">128</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="129" href="#129">129</a>                 <span class="string">"Path of origin may not be null."</span>);
<a name="130" href="#130">130</a>         }
<a name="131" href="#131">131</a>         <strong>if</strong> (header == <strong>null</strong>) {
<a name="132" href="#132">132</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Header may not be null."</span>);
<a name="133" href="#133">133</a>         }
<a name="134" href="#134">134</a> 
<a name="135" href="#135">135</a>         <strong>if</strong> (path.trim().equals(<span class="string">""</span>)) {
<a name="136" href="#136">136</a>             path = PATH_DELIM;
<a name="137" href="#137">137</a>         }
<a name="138" href="#138">138</a>         host = host.toLowerCase();
<a name="139" href="#139">139</a> 
<a name="140" href="#140">140</a>         String defaultPath = path;    
<a name="141" href="#141">141</a>         <strong>int</strong> lastSlashIndex = defaultPath.lastIndexOf(PATH_DELIM);
<a name="142" href="#142">142</a>         <strong>if</strong> (lastSlashIndex >= 0) {
<a name="143" href="#143">143</a>             <strong>if</strong> (lastSlashIndex == 0) {
<a name="144" href="#144">144</a>                 <em class="comment">//Do not remove the very first slash</em>
<a name="145" href="#145">145</a>                 lastSlashIndex = 1;
<a name="146" href="#146">146</a>             }
<a name="147" href="#147">147</a>             defaultPath = defaultPath.substring(0, lastSlashIndex);
<a name="148" href="#148">148</a>         }
<a name="149" href="#149">149</a> 
<a name="150" href="#150">150</a>         <a href="../../../../../org/apache/commons/httpclient/HeaderElement.html">HeaderElement</a>[] headerElements = <strong>null</strong>;
<a name="151" href="#151">151</a> 
<a name="152" href="#152">152</a>         <strong>boolean</strong> isNetscapeCookie = false; 
<a name="153" href="#153">153</a>         <strong>int</strong> i1 = header.toLowerCase().indexOf(<span class="string">"expires="</span>);
<a name="154" href="#154">154</a>         <strong>if</strong> (i1 != -1) {
<a name="155" href="#155">155</a>             i1 += <span class="string">"expires="</span>.length();
<a name="156" href="#156">156</a>             <strong>int</strong> i2 = header.indexOf(<span class="string">";"</span>, i1);
<a name="157" href="#157">157</a>             <strong>if</strong> (i2 == -1) {
<a name="158" href="#158">158</a>                 i2 = header.length(); 
<a name="159" href="#159">159</a>             }
<a name="160" href="#160">160</a>             <strong>try</strong> {
<a name="161" href="#161">161</a>                 DateUtil.parseDate(header.substring(i1, i2), <strong>this</strong>.datepatterns);
<a name="162" href="#162">162</a>                 isNetscapeCookie = <strong>true</strong>; 
<a name="163" href="#163">163</a>             } <strong>catch</strong> (DateParseException e) {
<a name="164" href="#164">164</a>                 <em class="comment">// Does not look like a valid expiry date</em>
<a name="165" href="#165">165</a>             }
<a name="166" href="#166">166</a>         }
<a name="167" href="#167">167</a>         <strong>if</strong> (isNetscapeCookie) {
<a name="168" href="#168">168</a>             headerElements = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/HeaderElement.html">HeaderElement</a>[] {
<a name="169" href="#169">169</a>                     <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/HeaderElement.html">HeaderElement</a>(header.toCharArray())
<a name="170" href="#170">170</a>             };
<a name="171" href="#171">171</a>         } <strong>else</strong> {
<a name="172" href="#172">172</a>             headerElements = HeaderElement.parseElements(header.toCharArray());
<a name="173" href="#173">173</a>         }
<a name="174" href="#174">174</a>         
<a name="175" href="#175">175</a>         <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] cookies = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[headerElements.length];
<a name="176" href="#176">176</a> 
<a name="177" href="#177">177</a>         <strong>for</strong> (<strong>int</strong> i = 0; i &lt; headerElements.length; i++) {
<a name="178" href="#178">178</a> 
<a name="179" href="#179">179</a>             <a href="../../../../../org/apache/commons/httpclient/HeaderElement.html">HeaderElement</a> headerelement = headerElements[i];
<a name="180" href="#180">180</a>             <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie = <strong>null</strong>;
<a name="181" href="#181">181</a>             <strong>try</strong> {
<a name="182" href="#182">182</a>                 cookie = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>(host,
<a name="183" href="#183">183</a>                                     headerelement.getName(),
<a name="184" href="#184">184</a>                                     headerelement.getValue(),
<a name="185" href="#185">185</a>                                     defaultPath, 
<a name="186" href="#186">186</a>                                     <strong>null</strong>,
<a name="187" href="#187">187</a>                                     false);
<a name="188" href="#188">188</a>             } <strong>catch</strong> (IllegalArgumentException e) {
<a name="189" href="#189">189</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(e.getMessage()); 
<a name="190" href="#190">190</a>             }
<a name="191" href="#191">191</a>             <em class="comment">// cycle through the parameters</em>
<a name="192" href="#192">192</a>             <a href="../../../../../org/apache/commons/httpclient/NameValuePair.html">NameValuePair</a>[] parameters = headerelement.getParameters();
<a name="193" href="#193">193</a>             <em class="comment">// could be null. In case only a header element and no parameters.</em>
<a name="194" href="#194">194</a>             <strong>if</strong> (parameters != <strong>null</strong>) {
<a name="195" href="#195">195</a> 
<a name="196" href="#196">196</a>                 <strong>for</strong> (<strong>int</strong> j = 0; j &lt; parameters.length; j++) {
<a name="197" href="#197">197</a>                     parseAttribute(parameters[j], cookie);
<a name="198" href="#198">198</a>                 }
<a name="199" href="#199">199</a>             }
<a name="200" href="#200">200</a>             cookies[i] = cookie;
<a name="201" href="#201">201</a>         }
<a name="202" href="#202">202</a>         <strong>return</strong> cookies;
<a name="203" href="#203">203</a>     }
<a name="204" href="#204">204</a> 
<a name="205" href="#205">205</a> 
<a name="206" href="#206">206</a>     <em>/**<em>*</em></em>
<a name="207" href="#207">207</a> <em>      * Parse the &lt;tt>"Set-Cookie"&lt;/tt> {@link Header} into an array of {@link</em>
<a name="208" href="#208">208</a> <em>      * Cookie}s.</em>
<a name="209" href="#209">209</a> <em>      *</em>
<a name="210" href="#210">210</a> <em>      * &lt;P>The syntax for the Set-Cookie response header is:</em>
<a name="211" href="#211">211</a> <em>      *</em>
<a name="212" href="#212">212</a> <em>      * &lt;PRE></em>
<a name="213" href="#213">213</a> <em>      * set-cookie      =    "Set-Cookie:" cookies</em>
<a name="214" href="#214">214</a> <em>      * cookies         =    1#cookie</em>
<a name="215" href="#215">215</a> <em>      * cookie          =    NAME "=" VALUE * (";" cookie-av)</em>
<a name="216" href="#216">216</a> <em>      * NAME            =    attr</em>
<a name="217" href="#217">217</a> <em>      * VALUE           =    value</em>
<a name="218" href="#218">218</a> <em>      * cookie-av       =    "Comment" "=" value</em>
<a name="219" href="#219">219</a> <em>      *                 |    "Domain" "=" value</em>
<a name="220" href="#220">220</a> <em>      *                 |    "Max-Age" "=" value</em>
<a name="221" href="#221">221</a> <em>      *                 |    "Path" "=" value</em>
<a name="222" href="#222">222</a> <em>      *                 |    "Secure"</em>
<a name="223" href="#223">223</a> <em>      *                 |    "Version" "=" 1*DIGIT</em>
<a name="224" href="#224">224</a> <em>      * &lt;/PRE></em>
<a name="225" href="#225">225</a> <em>      *</em>
<a name="226" href="#226">226</a> <em>      * @param host the host from which the &lt;tt>Set-Cookie&lt;/tt> header was</em>
<a name="227" href="#227">227</a> <em>      * received</em>
<a name="228" href="#228">228</a> <em>      * @param port the port from which the &lt;tt>Set-Cookie&lt;/tt> header was</em>
<a name="229" href="#229">229</a> <em>      * received</em>
<a name="230" href="#230">230</a> <em>      * @param path the path from which the &lt;tt>Set-Cookie&lt;/tt> header was</em>
<a name="231" href="#231">231</a> <em>      * received</em>
<a name="232" href="#232">232</a> <em>      * @param secure &lt;tt>true&lt;/tt> when the &lt;tt>Set-Cookie&lt;/tt> header was</em>
<a name="233" href="#233">233</a> <em>      * received over secure conection</em>
<a name="234" href="#234">234</a> <em>      * @param header the &lt;tt>Set-Cookie&lt;/tt> received from the server</em>
<a name="235" href="#235">235</a> <em>      * @return an array of &lt;tt>Cookie&lt;/tt>s parsed from the &lt;tt>"Set-Cookie"</em>
<a name="236" href="#236">236</a> <em>      * &lt;/tt> header</em>
<a name="237" href="#237">237</a> <em>      * @throws MalformedCookieException if an exception occurs during parsing</em>
<a name="238" href="#238">238</a> <em>      */</em>
<a name="239" href="#239">239</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] parse(
<a name="240" href="#240">240</a>         String host, <strong>int</strong> port, String path, <strong>boolean</strong> secure, <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Header.html">Header</a> header)
<a name="241" href="#241">241</a>         throws <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> {
<a name="242" href="#242">242</a>             
<a name="243" href="#243">243</a>         LOG.trace(<span class="string">"enter CookieSpecBase.parse("</span>
<a name="244" href="#244">244</a>             + <span class="string">"String, port, path, boolean, String)"</span>);
<a name="245" href="#245">245</a>         <strong>if</strong> (header == <strong>null</strong>) {
<a name="246" href="#246">246</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Header may not be null."</span>);
<a name="247" href="#247">247</a>         }
<a name="248" href="#248">248</a>         <strong>return</strong> parse(host, port, path, secure, header.getValue());
<a name="249" href="#249">249</a>     }
<a name="250" href="#250">250</a> 
<a name="251" href="#251">251</a> 
<a name="252" href="#252">252</a>     <em>/**<em>*</em></em>
<a name="253" href="#253">253</a> <em>      * Parse the cookie attribute and update the corresponsing {@link Cookie}</em>
<a name="254" href="#254">254</a> <em>      * properties.</em>
<a name="255" href="#255">255</a> <em>      *</em>
<a name="256" href="#256">256</a> <em>      * @param attribute {@link HeaderElement} cookie attribute from the</em>
<a name="257" href="#257">257</a> <em>      * &lt;tt>Set- Cookie&lt;/tt></em>
<a name="258" href="#258">258</a> <em>      * @param cookie {@link Cookie} to be updated</em>
<a name="259" href="#259">259</a> <em>      * @throws MalformedCookieException if an exception occurs during parsing</em>
<a name="260" href="#260">260</a> <em>      */</em>
<a name="261" href="#261">261</a> 
<a name="262" href="#262">262</a>     <strong>public</strong> <strong>void</strong> parseAttribute(
<a name="263" href="#263">263</a>         <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/NameValuePair.html">NameValuePair</a> attribute, <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie)
<a name="264" href="#264">264</a>         throws <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> {
<a name="265" href="#265">265</a>             
<a name="266" href="#266">266</a>         <strong>if</strong> (attribute == <strong>null</strong>) {
<a name="267" href="#267">267</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Attribute may not be null."</span>);
<a name="268" href="#268">268</a>         }
<a name="269" href="#269">269</a>         <strong>if</strong> (cookie == <strong>null</strong>) {
<a name="270" href="#270">270</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Cookie may not be null."</span>);
<a name="271" href="#271">271</a>         }
<a name="272" href="#272">272</a>         <strong>final</strong> String paramName = attribute.getName().toLowerCase();
<a name="273" href="#273">273</a>         String paramValue = attribute.getValue();
<a name="274" href="#274">274</a> 
<a name="275" href="#275">275</a>         <strong>if</strong> (paramName.equals(<span class="string">"path"</span>)) {
<a name="276" href="#276">276</a> 
<a name="277" href="#277">277</a>             <strong>if</strong> ((paramValue == <strong>null</strong>) || (paramValue.trim().equals(<span class="string">""</span>))) {
<a name="278" href="#278">278</a>                 paramValue = <span class="string">"/"</span>;
<a name="279" href="#279">279</a>             }
<a name="280" href="#280">280</a>             cookie.setPath(paramValue);
<a name="281" href="#281">281</a>             cookie.setPathAttributeSpecified(<strong>true</strong>);
<a name="282" href="#282">282</a> 
<a name="283" href="#283">283</a>         } <strong>else</strong> <strong>if</strong> (paramName.equals(<span class="string">"domain"</span>)) {
<a name="284" href="#284">284</a> 
<a name="285" href="#285">285</a>             <strong>if</strong> (paramValue == <strong>null</strong>) {
<a name="286" href="#286">286</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="287" href="#287">287</a>                     <span class="string">"Missing value for domain attribute"</span>);
<a name="288" href="#288">288</a>             }
<a name="289" href="#289">289</a>             <strong>if</strong> (paramValue.trim().equals(<span class="string">""</span>)) {
<a name="290" href="#290">290</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="291" href="#291">291</a>                     <span class="string">"Blank value for domain attribute"</span>);
<a name="292" href="#292">292</a>             }
<a name="293" href="#293">293</a>             cookie.setDomain(paramValue);
<a name="294" href="#294">294</a>             cookie.setDomainAttributeSpecified(<strong>true</strong>);
<a name="295" href="#295">295</a> 
<a name="296" href="#296">296</a>         } <strong>else</strong> <strong>if</strong> (paramName.equals(<span class="string">"max-age"</span>)) {
<a name="297" href="#297">297</a> 
<a name="298" href="#298">298</a>             <strong>if</strong> (paramValue == <strong>null</strong>) {
<a name="299" href="#299">299</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="300" href="#300">300</a>                     <span class="string">"Missing value for max-age attribute"</span>);
<a name="301" href="#301">301</a>             }
<a name="302" href="#302">302</a>             <strong>int</strong> age;
<a name="303" href="#303">303</a>             <strong>try</strong> {
<a name="304" href="#304">304</a>                 age = Integer.parseInt(paramValue);
<a name="305" href="#305">305</a>             } <strong>catch</strong> (NumberFormatException e) {
<a name="306" href="#306">306</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> (<span class="string">"Invalid max-age "</span>
<a name="307" href="#307">307</a>                     + <span class="string">"attribute: "</span> + e.getMessage());
<a name="308" href="#308">308</a>             }
<a name="309" href="#309">309</a>             cookie.setExpiryDate(
<a name="310" href="#310">310</a>                 <strong>new</strong> Date(System.currentTimeMillis() + age * 1000L));
<a name="311" href="#311">311</a> 
<a name="312" href="#312">312</a>         } <strong>else</strong> <strong>if</strong> (paramName.equals(<span class="string">"secure"</span>)) {
<a name="313" href="#313">313</a> 
<a name="314" href="#314">314</a>             cookie.setSecure(<strong>true</strong>);
<a name="315" href="#315">315</a> 
<a name="316" href="#316">316</a>         } <strong>else</strong> <strong>if</strong> (paramName.equals(<span class="string">"comment"</span>)) {
<a name="317" href="#317">317</a> 
<a name="318" href="#318">318</a>             cookie.setComment(paramValue);
<a name="319" href="#319">319</a> 
<a name="320" href="#320">320</a>         } <strong>else</strong> <strong>if</strong> (paramName.equals(<span class="string">"expires"</span>)) {
<a name="321" href="#321">321</a> 
<a name="322" href="#322">322</a>             <strong>if</strong> (paramValue == <strong>null</strong>) {
<a name="323" href="#323">323</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="324" href="#324">324</a>                     <span class="string">"Missing value for expires attribute"</span>);
<a name="325" href="#325">325</a>             }
<a name="326" href="#326">326</a> 
<a name="327" href="#327">327</a>             <strong>try</strong> {
<a name="328" href="#328">328</a>                 cookie.setExpiryDate(DateUtil.parseDate(paramValue, <strong>this</strong>.datepatterns));
<a name="329" href="#329">329</a>             } <strong>catch</strong> (DateParseException dpe) {
<a name="330" href="#330">330</a>                 LOG.debug(<span class="string">"Error parsing cookie date"</span>, dpe);
<a name="331" href="#331">331</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="332" href="#332">332</a>                     <span class="string">"Unable to parse expiration date parameter: "</span> 
<a name="333" href="#333">333</a>                     + paramValue);
<a name="334" href="#334">334</a>             }
<a name="335" href="#335">335</a>         } <strong>else</strong> {
<a name="336" href="#336">336</a>             <strong>if</strong> (LOG.isDebugEnabled()) {
<a name="337" href="#337">337</a>                 LOG.debug(<span class="string">"Unrecognized cookie attribute: "</span> 
<a name="338" href="#338">338</a>                     + attribute.toString());
<a name="339" href="#339">339</a>             }
<a name="340" href="#340">340</a>         }
<a name="341" href="#341">341</a>     }
<a name="342" href="#342">342</a> 
<a name="343" href="#343">343</a>     
<a name="344" href="#344">344</a> 	<strong>public</strong> Collection getValidDateFormats() {
<a name="345" href="#345">345</a> 		<strong>return</strong> <strong>this</strong>.datepatterns;
<a name="346" href="#346">346</a> 	}
<a name="347" href="#347">347</a> 
<a name="348" href="#348">348</a> 	<strong>public</strong> <strong>void</strong> setValidDateFormats(<strong>final</strong> Collection datepatterns) {
<a name="349" href="#349">349</a> 		<strong>this</strong>.datepatterns = datepatterns;
<a name="350" href="#350">350</a> 	}
<a name="351" href="#351">351</a> 
<a name="352" href="#352">352</a> 	<em>/**<em>*</em></em>
<a name="353" href="#353">353</a> <em>      * Performs most common {@link Cookie} validation</em>
<a name="354" href="#354">354</a> <em>      *</em>
<a name="355" href="#355">355</a> <em>      * @param host the host from which the {@link Cookie} was received</em>
<a name="356" href="#356">356</a> <em>      * @param port the port from which the {@link Cookie} was received</em>
<a name="357" href="#357">357</a> <em>      * @param path the path from which the {@link Cookie} was received</em>
<a name="358" href="#358">358</a> <em>      * @param secure &lt;tt>true&lt;/tt> when the {@link Cookie} was received using a</em>
<a name="359" href="#359">359</a> <em>      * secure connection</em>
<a name="360" href="#360">360</a> <em>      * @param cookie The cookie to validate.</em>
<a name="361" href="#361">361</a> <em>      * @throws MalformedCookieException if an exception occurs during</em>
<a name="362" href="#362">362</a> <em>      * validation</em>
<a name="363" href="#363">363</a> <em>      */</em>
<a name="364" href="#364">364</a>     
<a name="365" href="#365">365</a>     <strong>public</strong> <strong>void</strong> validate(String host, <strong>int</strong> port, String path, 
<a name="366" href="#366">366</a>         <strong>boolean</strong> secure, <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie) 
<a name="367" href="#367">367</a>         throws <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> {
<a name="368" href="#368">368</a>             
<a name="369" href="#369">369</a>         LOG.trace(<span class="string">"enter CookieSpecBase.validate("</span>
<a name="370" href="#370">370</a>             + <span class="string">"String, port, path, boolean, Cookie)"</span>);
<a name="371" href="#371">371</a>         <strong>if</strong> (host == <strong>null</strong>) {
<a name="372" href="#372">372</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="373" href="#373">373</a>                 <span class="string">"Host of origin may not be null"</span>);
<a name="374" href="#374">374</a>         }
<a name="375" href="#375">375</a>         <strong>if</strong> (host.trim().equals(<span class="string">""</span>)) {
<a name="376" href="#376">376</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="377" href="#377">377</a>                 <span class="string">"Host of origin may not be blank"</span>);
<a name="378" href="#378">378</a>         }
<a name="379" href="#379">379</a>         <strong>if</strong> (port &lt; 0) {
<a name="380" href="#380">380</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Invalid port: "</span> + port);
<a name="381" href="#381">381</a>         }
<a name="382" href="#382">382</a>         <strong>if</strong> (path == <strong>null</strong>) {
<a name="383" href="#383">383</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="384" href="#384">384</a>                 <span class="string">"Path of origin may not be null."</span>);
<a name="385" href="#385">385</a>         }
<a name="386" href="#386">386</a>         <strong>if</strong> (path.trim().equals(<span class="string">""</span>)) {
<a name="387" href="#387">387</a>             path = PATH_DELIM;
<a name="388" href="#388">388</a>         }
<a name="389" href="#389">389</a>         host = host.toLowerCase();
<a name="390" href="#390">390</a>         <em class="comment">// check version</em>
<a name="391" href="#391">391</a>         <strong>if</strong> (cookie.getVersion() &lt; 0) {
<a name="392" href="#392">392</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a> (<span class="string">"Illegal version number "</span> 
<a name="393" href="#393">393</a>                 + cookie.getValue());
<a name="394" href="#394">394</a>         }
<a name="395" href="#395">395</a> 
<a name="396" href="#396">396</a>         <em class="comment">// security check... we musn't allow the server to give us an</em>
<a name="397" href="#397">397</a>         <em class="comment">// invalid domain scope</em>
<a name="398" href="#398">398</a> 
<a name="399" href="#399">399</a>         <em class="comment">// Validate the cookies domain attribute.  NOTE:  Domains without </em>
<a name="400" href="#400">400</a>         <em class="comment">// any dots are allowed to support hosts on private LANs that don't </em>
<a name="401" href="#401">401</a>         <em class="comment">// have DNS names.  Since they have no dots, to domain-match the </em>
<a name="402" href="#402">402</a>         <em class="comment">// request-host and domain must be identical for the cookie to sent </em>
<a name="403" href="#403">403</a>         <em class="comment">// back to the origin-server.</em>
<a name="404" href="#404">404</a>         <strong>if</strong> (host.indexOf(<span class="string">"."</span>) >= 0) {
<a name="405" href="#405">405</a>             <em class="comment">// Not required to have at least two dots.  RFC 2965.</em>
<a name="406" href="#406">406</a>             <em class="comment">// A Set-Cookie2 with Domain=ajax.com will be accepted.</em>
<a name="407" href="#407">407</a> 
<a name="408" href="#408">408</a>             <em class="comment">// domain must match host</em>
<a name="409" href="#409">409</a>             <strong>if</strong> (!host.endsWith(cookie.getDomain())) {
<a name="410" href="#410">410</a>                 String s = cookie.getDomain();
<a name="411" href="#411">411</a>                 <strong>if</strong> (s.startsWith(<span class="string">"."</span>)) {
<a name="412" href="#412">412</a>                     s = s.substring(1, s.length());
<a name="413" href="#413">413</a>                 }
<a name="414" href="#414">414</a>                 <strong>if</strong> (!host.equals(s)) { 
<a name="415" href="#415">415</a>                     <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="416" href="#416">416</a>                         <span class="string">"Illegal domain attribute \&quot;"</span> + cookie.getDomain() 
<a name="417" href="#417">417</a>                         + <span class="string">"\&quot;. Domain of origin: \&quot;"</span> + host + <span class="string">"\&quot;"</span>);
<a name="418" href="#418">418</a>                 }
<a name="419" href="#419">419</a>             }
<a name="420" href="#420">420</a>         } <strong>else</strong> {
<a name="421" href="#421">421</a>             <strong>if</strong> (!host.equals(cookie.getDomain())) {
<a name="422" href="#422">422</a>                 <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="423" href="#423">423</a>                     <span class="string">"Illegal domain attribute \&quot;"</span> + cookie.getDomain() 
<a name="424" href="#424">424</a>                     + <span class="string">"\&quot;. Domain of origin: \&quot;"</span> + host + <span class="string">"\&quot;"</span>);
<a name="425" href="#425">425</a>             }
<a name="426" href="#426">426</a>         }
<a name="427" href="#427">427</a> 
<a name="428" href="#428">428</a>         <em class="comment">// another security check... we musn't allow the server to give us a</em>
<a name="429" href="#429">429</a>         <em class="comment">// cookie that doesn't match this path</em>
<a name="430" href="#430">430</a> 
<a name="431" href="#431">431</a>         <strong>if</strong> (!path.startsWith(cookie.getPath())) {
<a name="432" href="#432">432</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/cookie/MalformedCookieException.html">MalformedCookieException</a>(
<a name="433" href="#433">433</a>                 <span class="string">"Illegal path attribute \&quot;"</span> + cookie.getPath() 
<a name="434" href="#434">434</a>                 + <span class="string">"\&quot;. Path of origin: \&quot;"</span> + path + <span class="string">"\&quot;"</span>);
<a name="435" href="#435">435</a>         }
<a name="436" href="#436">436</a>     }
<a name="437" href="#437">437</a> 
<a name="438" href="#438">438</a> 
<a name="439" href="#439">439</a>     <em>/**<em>*</em></em>
<a name="440" href="#440">440</a> <em>     * Return &lt;tt>true&lt;/tt> if the cookie should be submitted with a request</em>
<a name="441" href="#441">441</a> <em>     * with given attributes, &lt;tt>false&lt;/tt> otherwise.</em>
<a name="442" href="#442">442</a> <em>     * @param host the host to which the request is being submitted</em>
<a name="443" href="#443">443</a> <em>     * @param port the port to which the request is being submitted (ignored)</em>
<a name="444" href="#444">444</a> <em>     * @param path the path to which the request is being submitted</em>
<a name="445" href="#445">445</a> <em>     * @param secure &lt;tt>true&lt;/tt> if the request is using a secure connection</em>
<a name="446" href="#446">446</a> <em>     * @param cookie {@link Cookie} to be matched</em>
<a name="447" href="#447">447</a> <em>     * @return true if the cookie matches the criterium</em>
<a name="448" href="#448">448</a> <em>     */</em>
<a name="449" href="#449">449</a> 
<a name="450" href="#450">450</a>     <strong>public</strong> <strong>boolean</strong> match(String host, <strong>int</strong> port, String path, 
<a name="451" href="#451">451</a>         <strong>boolean</strong> secure, <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie) {
<a name="452" href="#452">452</a>             
<a name="453" href="#453">453</a>         LOG.trace(<span class="string">"enter CookieSpecBase.match("</span>
<a name="454" href="#454">454</a>             + <span class="string">"String, int, String, boolean, Cookie"</span>);
<a name="455" href="#455">455</a>             
<a name="456" href="#456">456</a>         <strong>if</strong> (host == <strong>null</strong>) {
<a name="457" href="#457">457</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="458" href="#458">458</a>                 <span class="string">"Host of origin may not be null"</span>);
<a name="459" href="#459">459</a>         }
<a name="460" href="#460">460</a>         <strong>if</strong> (host.trim().equals(<span class="string">""</span>)) {
<a name="461" href="#461">461</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="462" href="#462">462</a>                 <span class="string">"Host of origin may not be blank"</span>);
<a name="463" href="#463">463</a>         }
<a name="464" href="#464">464</a>         <strong>if</strong> (port &lt; 0) {
<a name="465" href="#465">465</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Invalid port: "</span> + port);
<a name="466" href="#466">466</a>         }
<a name="467" href="#467">467</a>         <strong>if</strong> (path == <strong>null</strong>) {
<a name="468" href="#468">468</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(
<a name="469" href="#469">469</a>                 <span class="string">"Path of origin may not be null."</span>);
<a name="470" href="#470">470</a>         }
<a name="471" href="#471">471</a>         <strong>if</strong> (cookie == <strong>null</strong>) {
<a name="472" href="#472">472</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Cookie may not be null"</span>);
<a name="473" href="#473">473</a>         }
<a name="474" href="#474">474</a>         <strong>if</strong> (path.trim().equals(<span class="string">""</span>)) {
<a name="475" href="#475">475</a>             path = PATH_DELIM;
<a name="476" href="#476">476</a>         }
<a name="477" href="#477">477</a>         host = host.toLowerCase();
<a name="478" href="#478">478</a>         <strong>if</strong> (cookie.getDomain() == <strong>null</strong>) {
<a name="479" href="#479">479</a>             LOG.warn(<span class="string">"Invalid cookie state: domain not specified"</span>);
<a name="480" href="#480">480</a>             <strong>return</strong> false;
<a name="481" href="#481">481</a>         }
<a name="482" href="#482">482</a>         <strong>if</strong> (cookie.getPath() == <strong>null</strong>) {
<a name="483" href="#483">483</a>             LOG.warn(<span class="string">"Invalid cookie state: path not specified"</span>);
<a name="484" href="#484">484</a>             <strong>return</strong> false;
<a name="485" href="#485">485</a>         }
<a name="486" href="#486">486</a>         
<a name="487" href="#487">487</a>         <strong>return</strong>
<a name="488" href="#488">488</a>             <em class="comment">// only add the cookie if it hasn't yet expired </em>
<a name="489" href="#489">489</a>             (cookie.getExpiryDate() == <strong>null</strong> 
<a name="490" href="#490">490</a>                 || cookie.getExpiryDate().after(<strong>new</strong> Date()))
<a name="491" href="#491">491</a>             <em class="comment">// and the domain pattern matches </em>
<a name="492" href="#492">492</a>             &amp;&amp; (domainMatch(host, cookie.getDomain()))
<a name="493" href="#493">493</a>             <em class="comment">// and the path is null or matching</em>
<a name="494" href="#494">494</a>             &amp;&amp; (pathMatch(path, cookie.getPath()))
<a name="495" href="#495">495</a>             <em class="comment">// and if the secure flag is set, only if the request is </em>
<a name="496" href="#496">496</a>             <em class="comment">// actually secure </em>
<a name="497" href="#497">497</a>             &amp;&amp; (cookie.getSecure() ? secure : <strong>true</strong>);      
<a name="498" href="#498">498</a>     }
<a name="499" href="#499">499</a> 
<a name="500" href="#500">500</a>     <em>/**<em>*</em></em>
<a name="501" href="#501">501</a> <em>     * Performs domain-match as implemented in common browsers.</em>
<a name="502" href="#502">502</a> <em>     * @param host The target host.</em>
<a name="503" href="#503">503</a> <em>     * @param domain The cookie domain attribute.</em>
<a name="504" href="#504">504</a> <em>     * @return true if the specified host matches the given domain.</em>
<a name="505" href="#505">505</a> <em>     */</em>
<a name="506" href="#506">506</a>     <strong>public</strong> <strong>boolean</strong> domainMatch(<strong>final</strong> String host, String domain) {
<a name="507" href="#507">507</a>         <strong>if</strong> (host.equals(domain)) {
<a name="508" href="#508">508</a>             <strong>return</strong> <strong>true</strong>;
<a name="509" href="#509">509</a>         }
<a name="510" href="#510">510</a>         <strong>if</strong> (!domain.startsWith(<span class="string">"."</span>)) {
<a name="511" href="#511">511</a>             domain = <span class="string">"."</span> + domain;
<a name="512" href="#512">512</a>         }
<a name="513" href="#513">513</a>         <strong>return</strong> host.endsWith(domain) || host.equals(domain.substring(1));
<a name="514" href="#514">514</a>     }
<a name="515" href="#515">515</a> 
<a name="516" href="#516">516</a>     <em>/**<em>*</em></em>
<a name="517" href="#517">517</a> <em>     * Performs path-match as implemented in common browsers.</em>
<a name="518" href="#518">518</a> <em>     * @param path The target path.</em>
<a name="519" href="#519">519</a> <em>     * @param topmostPath The cookie path attribute.</em>
<a name="520" href="#520">520</a> <em>     * @return true if the paths match</em>
<a name="521" href="#521">521</a> <em>     */</em>
<a name="522" href="#522">522</a>     <strong>public</strong> <strong>boolean</strong> pathMatch(<strong>final</strong> String path, <strong>final</strong> String topmostPath) {
<a name="523" href="#523">523</a>         <strong>boolean</strong> match = path.startsWith (topmostPath);
<a name="524" href="#524">524</a>         <em class="comment">// if there is a match and these values are not exactly the same we have</em>
<a name="525" href="#525">525</a>         <em class="comment">// to make sure we're not matcing "/foobar" and "/foo"</em>
<a name="526" href="#526">526</a>         <strong>if</strong> (match &amp;&amp; path.length() != topmostPath.length()) {
<a name="527" href="#527">527</a>             <strong>if</strong> (!topmostPath.endsWith(PATH_DELIM)) {
<a name="528" href="#528">528</a>                 match = (path.charAt(topmostPath.length()) == PATH_DELIM_CHAR);
<a name="529" href="#529">529</a>             }
<a name="530" href="#530">530</a>         }
<a name="531" href="#531">531</a>         <strong>return</strong> match;
<a name="532" href="#532">532</a>     }
<a name="533" href="#533">533</a> 
<a name="534" href="#534">534</a>     <em>/**<em>*</em></em>
<a name="535" href="#535">535</a> <em>     * Return an array of {@link Cookie}s that should be submitted with a</em>
<a name="536" href="#536">536</a> <em>     * request with given attributes, &lt;tt>false&lt;/tt> otherwise.</em>
<a name="537" href="#537">537</a> <em>     * @param host the host to which the request is being submitted</em>
<a name="538" href="#538">538</a> <em>     * @param port the port to which the request is being submitted (currently</em>
<a name="539" href="#539">539</a> <em>     * ignored)</em>
<a name="540" href="#540">540</a> <em>     * @param path the path to which the request is being submitted</em>
<a name="541" href="#541">541</a> <em>     * @param secure &lt;tt>true&lt;/tt> if the request is using a secure protocol</em>
<a name="542" href="#542">542</a> <em>     * @param cookies an array of &lt;tt>Cookie&lt;/tt>s to be matched</em>
<a name="543" href="#543">543</a> <em>     * @return an array of &lt;tt>Cookie&lt;/tt>s matching the criterium</em>
<a name="544" href="#544">544</a> <em>     */</em>
<a name="545" href="#545">545</a> 
<a name="546" href="#546">546</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] match(String host, <strong>int</strong> port, String path, 
<a name="547" href="#547">547</a>         <strong>boolean</strong> secure, <strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookies[]) {
<a name="548" href="#548">548</a>             
<a name="549" href="#549">549</a>         LOG.trace(<span class="string">"enter CookieSpecBase.match("</span>
<a name="550" href="#550">550</a>             + <span class="string">"String, int, String, boolean, Cookie[])"</span>);
<a name="551" href="#551">551</a> 
<a name="552" href="#552">552</a>         <strong>if</strong> (cookies == <strong>null</strong>) {
<a name="553" href="#553">553</a>             <strong>return</strong> <strong>null</strong>;
<a name="554" href="#554">554</a>         }
<a name="555" href="#555">555</a>         List matching = <strong>new</strong> LinkedList();
<a name="556" href="#556">556</a>         <strong>for</strong> (<strong>int</strong> i = 0; i &lt; cookies.length; i++) {
<a name="557" href="#557">557</a>             <strong>if</strong> (match(host, port, path, secure, cookies[i])) {
<a name="558" href="#558">558</a>                 addInPathOrder(matching, cookies[i]);
<a name="559" href="#559">559</a>             }
<a name="560" href="#560">560</a>         }
<a name="561" href="#561">561</a>         <strong>return</strong> (Cookie[]) matching.toArray(<strong>new</strong> Cookie[matching.size()]);
<a name="562" href="#562">562</a>     }
<a name="563" href="#563">563</a> 
<a name="564" href="#564">564</a> 
<a name="565" href="#565">565</a>     <em>/**<em>*</em></em>
<a name="566" href="#566">566</a> <em>     * Adds the given cookie into the given list in descending path order. That</em>
<a name="567" href="#567">567</a> <em>     * is, more specific path to least specific paths.  This may not be the</em>
<a name="568" href="#568">568</a> <em>     * fastest algorythm, but it'll work OK for the small number of cookies</em>
<a name="569" href="#569">569</a> <em>     * we're generally dealing with.</em>
<a name="570" href="#570">570</a> <em>     *</em>
<a name="571" href="#571">571</a> <em>     * @param list - the list to add the cookie to</em>
<a name="572" href="#572">572</a> <em>     * @param addCookie - the Cookie to add to list</em>
<a name="573" href="#573">573</a> <em>     */</em>
<a name="574" href="#574">574</a>     <strong>private</strong> <strong>static</strong> <strong>void</strong> addInPathOrder(List list, <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> addCookie) {
<a name="575" href="#575">575</a>         <strong>int</strong> i = 0;
<a name="576" href="#576">576</a> 
<a name="577" href="#577">577</a>         <strong>for</strong> (i = 0; i &lt; list.size(); i++) {
<a name="578" href="#578">578</a>             <a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> c = (Cookie) list.get(i);
<a name="579" href="#579">579</a>             <strong>if</strong> (addCookie.compare(addCookie, c) > 0) {
<a name="580" href="#580">580</a>                 <strong>break</strong>;
<a name="581" href="#581">581</a>             }
<a name="582" href="#582">582</a>         }
<a name="583" href="#583">583</a>         list.add(i, addCookie);
<a name="584" href="#584">584</a>     }
<a name="585" href="#585">585</a> 
<a name="586" href="#586">586</a>     <em>/**<em>*</em></em>
<a name="587" href="#587">587</a> <em>     * Return a string suitable for sending in a &lt;tt>"Cookie"&lt;/tt> header</em>
<a name="588" href="#588">588</a> <em>     * @param cookie a {@link Cookie} to be formatted as string</em>
<a name="589" href="#589">589</a> <em>     * @return a string suitable for sending in a &lt;tt>"Cookie"&lt;/tt> header.</em>
<a name="590" href="#590">590</a> <em>     */</em>
<a name="591" href="#591">591</a>     <strong>public</strong> String formatCookie(<a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie) {
<a name="592" href="#592">592</a>         LOG.trace(<span class="string">"enter CookieSpecBase.formatCookie(Cookie)"</span>);
<a name="593" href="#593">593</a>         <strong>if</strong> (cookie == <strong>null</strong>) {
<a name="594" href="#594">594</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Cookie may not be null"</span>);
<a name="595" href="#595">595</a>         }
<a name="596" href="#596">596</a>         StringBuffer buf = <strong>new</strong> StringBuffer();
<a name="597" href="#597">597</a>         buf.append(cookie.getName());
<a name="598" href="#598">598</a>         buf.append(<span class="string">"="</span>);
<a name="599" href="#599">599</a>         String s = cookie.getValue();
<a name="600" href="#600">600</a>         <strong>if</strong> (s != <strong>null</strong>) {
<a name="601" href="#601">601</a>             buf.append(s);
<a name="602" href="#602">602</a>         }
<a name="603" href="#603">603</a>         <strong>return</strong> buf.toString();
<a name="604" href="#604">604</a>     }
<a name="605" href="#605">605</a> 
<a name="606" href="#606">606</a>     <em>/**<em>*</em></em>
<a name="607" href="#607">607</a> <em>     * Create a &lt;tt>"Cookie"&lt;/tt> header value containing all {@link Cookie}s in</em>
<a name="608" href="#608">608</a> <em>     * &lt;i>cookies&lt;/i> suitable for sending in a &lt;tt>"Cookie"&lt;/tt> header</em>
<a name="609" href="#609">609</a> <em>     * @param cookies an array of {@link Cookie}s to be formatted</em>
<a name="610" href="#610">610</a> <em>     * @return a string suitable for sending in a Cookie header.</em>
<a name="611" href="#611">611</a> <em>     * @throws IllegalArgumentException if an input parameter is illegal</em>
<a name="612" href="#612">612</a> <em>     */</em>
<a name="613" href="#613">613</a> 
<a name="614" href="#614">614</a>     <strong>public</strong> String formatCookies(<a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] cookies)
<a name="615" href="#615">615</a>       throws IllegalArgumentException {
<a name="616" href="#616">616</a>         LOG.trace(<span class="string">"enter CookieSpecBase.formatCookies(Cookie[])"</span>);
<a name="617" href="#617">617</a>         <strong>if</strong> (cookies == <strong>null</strong>) {
<a name="618" href="#618">618</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Cookie array may not be null"</span>);
<a name="619" href="#619">619</a>         }
<a name="620" href="#620">620</a>         <strong>if</strong> (cookies.length == 0) {
<a name="621" href="#621">621</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Cookie array may not be empty"</span>);
<a name="622" href="#622">622</a>         }
<a name="623" href="#623">623</a> 
<a name="624" href="#624">624</a>         StringBuffer buffer = <strong>new</strong> StringBuffer();
<a name="625" href="#625">625</a>         <strong>for</strong> (<strong>int</strong> i = 0; i &lt; cookies.length; i++) {
<a name="626" href="#626">626</a>             <strong>if</strong> (i > 0) {
<a name="627" href="#627">627</a>                 buffer.append(<span class="string">"; "</span>);
<a name="628" href="#628">628</a>             }
<a name="629" href="#629">629</a>             buffer.append(formatCookie(cookies[i]));
<a name="630" href="#630">630</a>         }
<a name="631" href="#631">631</a>         <strong>return</strong> buffer.toString();
<a name="632" href="#632">632</a>     }
<a name="633" href="#633">633</a> 
<a name="634" href="#634">634</a> 
<a name="635" href="#635">635</a>     <em>/**<em>*</em></em>
<a name="636" href="#636">636</a> <em>     * Create a &lt;tt>"Cookie"&lt;/tt> {@link Header} containing all {@link Cookie}s</em>
<a name="637" href="#637">637</a> <em>     * in &lt;i>cookies&lt;/i>.</em>
<a name="638" href="#638">638</a> <em>     * @param cookies an array of {@link Cookie}s to be formatted as a &lt;tt>"</em>
<a name="639" href="#639">639</a> <em>     * Cookie"&lt;/tt> header</em>
<a name="640" href="#640">640</a> <em>     * @return a &lt;tt>"Cookie"&lt;/tt> {@link Header}.</em>
<a name="641" href="#641">641</a> <em>     */</em>
<a name="642" href="#642">642</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/Header.html">Header</a> formatCookieHeader(<a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a>[] cookies) {
<a name="643" href="#643">643</a>         LOG.trace(<span class="string">"enter CookieSpecBase.formatCookieHeader(Cookie[])"</span>);
<a name="644" href="#644">644</a>         <strong>return</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/Header.html">Header</a>(<span class="string">"Cookie"</span>, formatCookies(cookies));
<a name="645" href="#645">645</a>     }
<a name="646" href="#646">646</a> 
<a name="647" href="#647">647</a> 
<a name="648" href="#648">648</a>     <em>/**<em>*</em></em>
<a name="649" href="#649">649</a> <em>     * Create a &lt;tt>"Cookie"&lt;/tt> {@link Header} containing the {@link Cookie}.</em>
<a name="650" href="#650">650</a> <em>     * @param cookie &lt;tt>Cookie&lt;/tt>s to be formatted as a &lt;tt>Cookie&lt;/tt></em>
<a name="651" href="#651">651</a> <em>     * header</em>
<a name="652" href="#652">652</a> <em>     * @return a Cookie header.</em>
<a name="653" href="#653">653</a> <em>     */</em>
<a name="654" href="#654">654</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/Header.html">Header</a> formatCookieHeader(<a href="../../../../../org/apache/commons/httpclient/Cookie.html">Cookie</a> cookie) {
<a name="655" href="#655">655</a>         LOG.trace(<span class="string">"enter CookieSpecBase.formatCookieHeader(Cookie)"</span>);
<a name="656" href="#656">656</a>         <strong>return</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/Header.html">Header</a>(<span class="string">"Cookie"</span>, formatCookie(cookie));
<a name="657" href="#657">657</a>     }
<a name="658" href="#658">658</a> 
<a name="659" href="#659">659</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

